definition module System._Windows

import _SystemArray
from StdOverloaded import class *(*), class +(+)
from StdInt import IF_INT_64_OR_32, <<, bitor, bitand
from System._Pointer import :: Pointer
from System.SysCall import class SysCallEnv

:: HANDLE	:== Int
:: PHANDLE  :== Int
:: DWORD	:== Int
:: LPDWORD	:== Int
:: LPCTSTR	:== Int
:: LPTSTR	:== Int
:: LPVOID	:== Int
:: LPCVOID	:== Int
:: SIZE_T	:== Int

:: HLOCAL   :== HANDLE

INVALID_HANDLE_VALUE :== -1

NULL :== 0
FALSE :== 0
TRUE  :== 1

MAX_PATH :== 260

INT_SIZE :== IF_INT_64_OR_32 8 4

:: FILETIME :== {#Char}
FILETIME_size_bytes :== FILETIME_size_int * INT_SIZE
FILETIME_size_int :== 2

:: LPSYSTEMTIME :== {#Char}
SYSTEMTIME_size_bytes			:== 16//4 * INT_SIZE//16
SYSTEMTIME_wYear_offset			:== 0
SYSTEMTIME_wMonth_offset		:== 2
SYSTEMTIME_wDayOfWeek_offset	:== 4
SYSTEMTIME_wDay_offset			:== 6
SYSTEMTIME_wHour_offset			:== 8
SYSTEMTIME_wMinute_offset		:== 10
SYSTEMTIME_wSecond_offset		:== 12
SYSTEMTIME_wMilliseconds_offset	:== 14

:: LPSECURITY_ATTRIBUTES :== Int
:: SECURITY_ATTRIBUTES   :== {#Int}
:: LPTHREAD_START_ROUTINE :==Int
:: LPOVERLAPPED :== Int
OVERLAPPED_SIZE_BYTES		:== IF_INT_64_OR_32 40 20
CRITICAL_SECTION_SIZE_BYTES	:== IF_INT_64_OR_32 48 24
:: LPCRITICAL_SECTION :== Int

:: LPSTARTUPINFO :== {#Int}
STARTUPINFO_size_bytes :== IF_INT_64_OR_32 104 68
STARTUPINFO_size_int :== IF_INT_64_OR_32 13 17
STARTUPINFO_cb_int_offset :== 0
STARTUPINFO_set_dwFlags dwFlags struct :== IF_INT_64_OR_32
	(let (v,s) = struct![7] in {s & [7]=(v bitand 0xffffffff) bitor (dwFlags << 32)})
	{struct & [11]=dwFlags}
STARTUPINFO_hStdInput_int_offset :== IF_INT_64_OR_32 10 14
STARTUPINFO_hStdOutput_int_offset :== IF_INT_64_OR_32 11 15
STARTUPINFO_hStdError_int_offset :== IF_INT_64_OR_32 12 16

STARTUPINFOEX_size_bytes :== STARTUPINFO_size_bytes + IF_INT_64_OR_32 8 4
STARTUPINFOEX_size_int :== STARTUPINFO_size_int + 1
STARTUPINFOEX_lpAttributeList_int_offset :== IF_INT_64_OR_32 13 17

:: LPPROC_THREAD_ATTRIBUTE_LIST :== Int
PROC_THREAD_ATTRIBUTE_HANDLE_LIST :== 0x00020002

:: LPWIN32_FIND_DATA :== {#Char}
WIN32_FIND_DATA_size_bytes :== 320
WIN32_FIND_DATA_dwFileAttributes_bytes_offset :== 0
WIN32_FIND_DATA_ftCreationTime_bytes_offset :== 4
WIN32_FIND_DATA_ftLastAccessTime_bytes_offset :== 12
WIN32_FIND_DATA_ftLastWriteTime_bytes_offset :== 20
WIN32_FIND_DATA_nFileSizeHigh_bytes_offset :==28 
WIN32_FIND_DATA_nFileSizeLow_bytes_offset :== 32
WIN32_FIND_DATA_cFileName_bytes_offset :== 44

FILE_ATTRIBUTE_DIRECTORY :== 16

:: LPPROCESS_INFORMATION :== Int
PROCESS_INFORMATION_size_bytes :== IF_INT_64_OR_32 24 16
PROCESS_INFORMATION_hProcess_bytes_offset :== 0
PROCESS_INFORMATION_hThread_bytes_offset :== IF_INT_64_OR_32 8 4

SECURITY_ATTRIBUTES_SIZE_BYTES							:== INT_SIZE * SECURITY_ATTRIBUTES_SIZE_INT
SECURITY_ATTRIBUTES_SIZE_INT                            :== 3
SECURITY_ATTRIBUTES_nLength_BYTES_OFFSET				:== 0
SECURITY_ATTRIBUTES_nLength_INT_OFFSET				    :== 0
SECURITY_ATTRIBUTES_lpSecurityDescriptor_BYTES_OFFSET	:== INT_SIZE
SECURITY_ATTRIBUTES_bInheritHandle_BYTES_OFFSET			:== INT_SIZE * 2
SECURITY_ATTRIBUTES_bInheritHandle_INT_OFFSET			:== 2

/*
 * Macros
 */

DETACHED_PROCESS :== 8
FORMAT_MESSAGE_ALLOCATE_BUFFER :== 0x00000100
FORMAT_MESSAGE_FROM_SYSTEM :== 0x00001000
FORMAT_MESSAGE_IGNORE_INSERTS :== 0x00000200
INFINITE :== 0xFFFFFFFF
LANGUAGE_NEUTRAL_SUBLANG_DEFAULT :== 0x400
STARTF_USESTDHANDLES :== 0x00000100
EXTENDED_STARTUPINFO_PRESENT :== 0x00080000
STATUS_PENDING :== 0x00000103
STILL_ACTIVE :== STATUS_PENDING
WAIT_ABANDONED_0 :== 0x80
WAIT_FAILED :== 0xFFFFFFFF
WAIT_OBJECT_0 :== 0
WAIT_TIMEOUT :== 258

GENERIC_READ :== 0x80000000
GENERIC_WRITE :== 0x40000000
FILE_SHARE_READ :== 0x00000001
FILE_SHARE_WRITE :== 0x00000002

CREATE_ALWAYS		:== 2
CREATE_NEW			:== 1
OPEN_ALWAYS			:== 4
OPEN_EXISTING		:== 3
TRUNCATE_EXISTING	:== 5

FILE_ATTRIBUTE_NORMAL :== 128
LOCKFILE_EXCLUSIVE_LOCK :== 0x00000002

HEAP_ZERO_MEMORY :== 0x00000008
CREATE_SUSPENDED :== 0x00000004
SYNCHRONIZE :== 0x00100000

HANDLE_FLAG_INHERIT :== 0x00000001

MOVEFILE_REPLACE_EXISTING :== 0x1
MOVEFILE_WRITE_THROUGH :== 0x8

/*
 * Windows API calls 
 */

closeHandle :: !HANDLE !*env -> (!Bool,!*env) | SysCallEnv env special env=World
setHandleInformation :: !HANDLE !DWORD !DWORD !*env -> (!Bool, !*env) | SysCallEnv env special env=World
	
createFileA :: !String !DWORD !DWORD !LPSECURITY_ATTRIBUTES
	!DWORD !DWORD !HANDLE !*env -> (!HANDLE, !*env) | SysCallEnv env special env=World
	
readFile :: !HANDLE !LPVOID !DWORD !LPDWORD !LPOVERLAPPED !*env -> (!Bool, !*env) | SysCallEnv env special env=World

writeFile :: !HANDLE !String !DWORD !LPDWORD !LPOVERLAPPED !*env -> (!Bool, !*env) | SysCallEnv env special env=World

setEndOfFile :: !HANDLE !*env -> (!Bool, !*env) | SysCallEnv env special env=World

lockFileEx :: !HANDLE !DWORD !DWORD !DWORD !DWORD !LPOVERLAPPED !*env -> (!Bool, !*env) | SysCallEnv env special env=World

unlockFile :: !HANDLE !DWORD !DWORD !DWORD !DWORD !*env -> (!Bool, !*env) | SysCallEnv env special env=World

getFileSize :: !HANDLE !LPDWORD !*env -> (!DWORD, !*env) | SysCallEnv env special env=World

getFullPathNameA :: !String !DWORD !String !LPTSTR !*env -> (!DWORD, !*env) | SysCallEnv env special env=World

createDirectoryA :: !String !LPSECURITY_ATTRIBUTES !*env -> (!Bool, !*env) | SysCallEnv env special env=World

initializeProcThreadAttributeList :: !LPPROC_THREAD_ATTRIBUTE_LIST !Int !Int !Int !*env -> (!Bool, !*env) | SysCallEnv env special env=World
updateProcThreadAttribute :: !LPPROC_THREAD_ATTRIBUTE_LIST !Int !Int !LPVOID !Int !LPVOID !LPVOID !*env -> (!Bool, !*env) | SysCallEnv env special env=World
deleteProcThreadAttributeList :: !LPPROC_THREAD_ATTRIBUTE_LIST !*env -> *env | SysCallEnv env special env=World

createProcessA :: !String !String !LPSECURITY_ATTRIBUTES !LPSECURITY_ATTRIBUTES !Bool !Int !LPVOID
					!LPCTSTR !LPSTARTUPINFO !LPPROCESS_INFORMATION !*env -> (!Bool,!*env) | SysCallEnv env special env=World

createProcessA_dir :: !String !String !LPSECURITY_ATTRIBUTES !LPSECURITY_ATTRIBUTES !Bool !Int !LPVOID
					!String !LPSTARTUPINFO !LPPROCESS_INFORMATION !*env -> (!Bool,!*env) | SysCallEnv env special env=World

createProcessA_noApplication :: !Int !String !LPSECURITY_ATTRIBUTES !LPSECURITY_ATTRIBUTES !Bool !Int !LPVOID
					!LPCTSTR !LPSTARTUPINFO !LPPROCESS_INFORMATION !*env -> (!Bool,!*env) | SysCallEnv env special env=World

createProcessA_noApplication_dir :: !Int !String !LPSECURITY_ATTRIBUTES !LPSECURITY_ATTRIBUTES !Bool !Int !LPVOID
					!String !LPSTARTUPINFO !LPPROCESS_INFORMATION !*env -> (!Bool,!*env) | SysCallEnv env special env=World

terminateProcess :: !HANDLE !Int !*env -> (!Bool, !*env) | SysCallEnv env special env=World

deleteFileA :: !String !*env -> (!Int, !*env) | SysCallEnv env special env=World

fileTimeToSystemTime :: !FILETIME !LPSYSTEMTIME !*env -> (!Bool, *env) | SysCallEnv env special env=World

findClose :: !HANDLE !*env -> (!Bool, !*env) | SysCallEnv env special env=World

findFirstFileA :: !String !LPWIN32_FIND_DATA !*env -> (!HANDLE, !*env) | SysCallEnv env special env=World

findNextFileA :: !HANDLE !LPWIN32_FIND_DATA !*env -> (!Bool, !*env) | SysCallEnv env special env=World

formatMessageA :: !DWORD !LPCVOID !DWORD !DWORD !{#LPTSTR} !DWORD !Int !*env -> (!DWORD, !*env) | SysCallEnv env special env=World

getCurrentDirectoryA :: !DWORD !{#Char} !*env -> (!DWORD, *env) | SysCallEnv env special env=World

getExitCodeProcess :: !HANDLE !*env -> (!Bool,!Int,!*env) | SysCallEnv env special env=World


getLastError :: !*env -> (!Int, !*env) | SysCallEnv env special env=World

localFree :: !HLOCAL -> HLOCAL

moveFileA :: !String !String !*env -> (!Bool, !*env) | SysCallEnv env special env=World

moveFileExA :: !String !String !Int !*env -> (!Bool, !*env) | SysCallEnv env special env=World

copyFileA :: !String !String !Bool !*env -> (!Bool, !*env) | SysCallEnv env special env=World

removeDirectoryA :: !String !*env -> (!Bool, !*env) | SysCallEnv env special env=World

setCurrentDirectoryA :: !String !*env -> (!Bool, !*env) | SysCallEnv env special env=World

waitForSingleObject :: !HANDLE !Int !*env -> (!Int,!*env) | SysCallEnv env special env=World

waitForMultipleObjects :: !Int !{#HANDLE} !Bool !Int !*env -> (!Int, !*env) | SysCallEnv env special env=World

getProcessHeap :: !*env -> (!HANDLE, !*env) | SysCallEnv env special env=World

heapAlloc :: !HANDLE !DWORD !SIZE_T !*env -> (!LPVOID, !*env) | SysCallEnv env special env=World
heapFree :: !HANDLE !DWORD !LPVOID !*env -> (!Bool, !*env) | SysCallEnv env special env=World
heapCreate :: !DWORD !SIZE_T !SIZE_T !*env -> (!HANDLE, !*env) | SysCallEnv env special env=World

CreateThread :: !LPSECURITY_ATTRIBUTES !SIZE_T !LPTHREAD_START_ROUTINE !LPVOID !DWORD !*env -> (!HANDLE,!DWORD,!*env) | SysCallEnv env special env=World
ResumeThread :: !HANDLE !*env -> (!DWORD, *env) | SysCallEnv env special env=World
TerminateThread :: !HANDLE !DWORD !*env -> (!Bool, *env) | SysCallEnv env special env=World
getExitCodeThread :: !HANDLE !*env -> (!Bool,!Int,!*env) | SysCallEnv env special env=World

initializeCriticalSection :: !LPCRITICAL_SECTION !*env -> *env | SysCallEnv env special env=World
initializeCriticalSectionAndSpinCount :: !LPCRITICAL_SECTION !DWORD !*env -> (!Bool, !*env) | SysCallEnv env special env=World
enterCriticalSection :: !LPCRITICAL_SECTION !*env -> *env | SysCallEnv env special env=World
leaveCriticalSection :: !LPCRITICAL_SECTION !*env -> *env | SysCallEnv env special env=World

createMutexA :: !LPSECURITY_ATTRIBUTES !Bool !LPCTSTR !*env -> (!HANDLE, !*env) | SysCallEnv env special env=World
releaseMutex :: !HANDLE !*env -> (!Bool, !*env) | SysCallEnv env special env=World
createEventA :: !LPSECURITY_ATTRIBUTES !Bool !Bool !LPCTSTR !*env -> (!HANDLE, !*env) | SysCallEnv env special env=World
setEvent :: !HANDLE !*env -> (!Bool, !*env) | SysCallEnv env special env=World

WinGetThreadId :: !HANDLE !*env -> (!DWORD, !*env) | SysCallEnv env special env=World
WinGetCurrentThreadId :: !*env -> (!DWORD, !*env) | SysCallEnv env special env=World
WinOpenThread :: !DWORD !Bool !DWORD *env -> (!DWORD, !*env) | SysCallEnv env special env=World

sleep :: !DWORD !*env -> *env | SysCallEnv env special env=World

createPipe :: !PHANDLE !PHANDLE !SECURITY_ATTRIBUTES !DWORD !*env -> (!Bool, !*env) | SysCallEnv env special env=World
peekNamedPipe :: !HANDLE !LPVOID !DWORD !LPDWORD !LPDWORD !LPDWORD !*env -> (!Bool, !*env) | SysCallEnv env special env=World
cancelSynchronousIo :: !HANDLE !*env -> (!Bool, !*env) | SysCallEnv env special env=World

GetSystemTimeAsFileTime :: !{#Int} !*env -> (!{#Int},!*env) | SysCallEnv env special env=World

_execvp :: !{#Char} !{#Pointer} !*env -> (!Int, !*env) | SysCallEnv env special env=World

GetEnvironmentVariableA :: !{#Char} !{#Char} !Int !*env -> (!Int, !*env) | SysCallEnv env special env=World
SetEnvironmentVariableA :: !{#Char} !Int !*env -> (!Int, !*env) | SysCallEnv env special env=World
//* Variant where you pass a string instead of a pointer
SetEnvironmentVariableA` :: !{#Char} !{#Char} !*env -> (!Int, !*env) | SysCallEnv env special env=World

_mkgmtime :: !{#Int} !*env -> (!Int, !*env) | SysCallEnv env

WSAStartup :: !Int !{#Int} !*env -> (!Int, !*env) | SysCallEnv env special env=World
WSACleanup :: !*env -> (!Int, !*env) | SysCallEnv env special env=World
gethostbyname :: !{#Char} !*env -> (!Pointer, !*env) | SysCallEnv env special env=World

malloc :: !Int !*env -> (!Pointer, !*env) | SysCallEnv env special env=World
free :: !Pointer !*env -> *env | SysCallEnv env special env=World
memcpy :: !Pointer !Pointer !Int !*env -> *env | SysCallEnv env special env=World
//* Variant that allows copying from a pointer to a Clean string
memcpyStringToPointer :: !Pointer !{#Char} !Int !*env -> *env | SysCallEnv env special env=World
//* Variant that allows copying from a Clean string to a pointer
memcpyPointerToString :: !{#Char} !Pointer !Int !*env -> *env | SysCallEnv env special env=World
memcmp :: !Pointer !Pointer !Int !*env -> (!Int, !*env) | SysCallEnv env special env=World

timegm :: !{#Int} !*env -> *(!Int, !*env) | SysCallEnv env special env=World
//timegm is a pure C function so this is safe to do without an environment
timegm` :: !{#Int} -> Int
asctime :: !{#Int} !*env -> (!Pointer, !*env) | SysCallEnv env special env=World
ctime :: !{#Int} !*env -> *(!Pointer, !*env) | SysCallEnv env special env=World
clock :: !*env -> (!Int, !*env) | SysCallEnv env special env=World
time :: !Int !*env -> (!Int,!*env) | SysCallEnv env special env=World
gmtime :: !{#Int} !*env -> (!Pointer, !*env) | SysCallEnv env special env=World
mktime :: !{#Int} !*env -> (!Int, !*env) | SysCallEnv env special env=World
//strftime is a pure C function so this is safe to do without an environment
strftime` :: !{#Char} !Int !{#Char} !{#Int} !{#Char} -> (!Int,!{#Char})
localtime :: !{#Int} !*env -> (!Pointer, !*env) | SysCallEnv env special env=World
